(*
 * <COPYRIGHT>
 * Copyright 2005 Gerd Stolpmann
 *
 * <GPL>
 * This file is part of UMLMON.
 *
 * UMLMON is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * UMLMON is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with UMLMON; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * </>
 *)

(* $Id: umlmon_mconsole.mli 187 2005-10-14 10:54:15Z gerd $ *)

(* Procedures using the mconsole socket *)

open Umlmon_types

val proc_get_ssl :
  umlstatus ->
  Rpc_server.session ->
  int32 ->
  (string option -> unit) ->
    unit
  (* Implements the [get_ssl] procedure *)

val proc_get_con :
  umlstatus ->
  Rpc_server.session ->
  int32 ->
  (string option -> unit) ->
    unit
  (* Implements the [get_con] procedure *)

val proc_get_ubd :
  umlstatus ->
  Rpc_server.session ->
  int32 ->
  (string option -> unit) ->
    unit
  (* Implements the [get_ubd] procedure *)

val proc_get_eth :
  umlstatus ->
  Rpc_server.session ->
  int32 ->
  (string option -> unit) ->
    unit
  (* Implements the [get_eth] procedure *)

val proc_stop :
  umlstatus ->
  Rpc_server.session ->
  unit ->
  (Umlmonctrl_aux.r_simple -> unit) ->
    unit
  (* Implements the [stop] procedure *)

val proc_continue :
  umlstatus ->
  Rpc_server.session ->
  unit ->
  (Umlmonctrl_aux.r_simple -> unit) ->
    unit
  (* Implements the [continue] procedure *)

val proc_halt :
  umlstatus ->
  Rpc_server.session ->
  unit ->
  (Umlmonctrl_aux.r_simple -> unit) ->
    unit
  (* Implements the [halt] procedure *)

val proc_ctrlaltdel :
  umlstatus ->
  Rpc_server.session ->
  unit ->
  (Umlmonctrl_aux.r_simple -> unit) ->
    unit
  (* Implements the [ctrlaltdel] procedure *)

val proc_sysrq :
  umlstatus ->
  Rpc_server.session ->
  string ->
  (Umlmonctrl_aux.r_simple -> unit) ->
    unit
  (* Implements the [sysrq] procedure *)
