(*
 * <COPYRIGHT>
 * Copyright 2005 Gerd Stolpmann
 *
 * <GPL>
 * This file is part of UMLMON-Web.
 *
 * UMLMON-Web is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * UMLMON-Web is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with UMLMON-Web; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * </>
 *)

(* $Id: main.ml 121 2005-06-12 13:56:40Z gerd $
 * ----------------------------------------------------------------------
 *
 *)

open Printf

let print_version() =
  printf "UMLMON-Web Release %s Revision %s\n" Instconf.release Instconf.revision;
  printf "Copyright 2005 Informatikbuero Gerd Stolpmann.\n\n";

  printf "This program is free software; you can redistribute it and/or\n";
  printf "modify it under the terms of the GNU General Public License\n";
  printf "as published by the Free Software Foundation; either version 2\n";
  printf "of the License, or (at your option) any later version.\n\n";

  printf "This program is distributed in the hope that it will be useful,\n";
  printf "but WITHOUT ANY WARRANTY; without even the implied warranty of\n";
  printf "MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the\n";
  printf "GNU General Public License for more details.\n\n";

  printf "You should have received a copy of the GNU General Public License\n";
  printf "along with this program; if not, write to the Free Software\n";
  printf "Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.\n\n";
  flush stdout;
  exit 0
;;




let main() =
  if Array.length Sys.argv > 1 && Sys.argv.(1) = "-version" then
    print_version();

  let uifile =
    if Sys.file_exists "umlmon_web.ui" then
      "umlmon_web.ui"
    else
      Filename.concat Instconf.prefix "share/umlmon_web/ui/umlmon_web.ui" in
  let name = Sys.argv.(0) in
  if Filename.check_suffix name ".cgi" then
    Main_cgi.main ~uifile ()
  else
    if Filename.check_suffix name ".fcgi" then
      Main_fcgi.main ~uifile ()
    else
      failwith "Don't know what to do!"
;;

main();;
