(*
 * <COPYRIGHT>
 * Copyright 2005 Gerd Stolpmann
 *
 * <GPL>
 * This file is part of UMLMON-Web.
 *
 * UMLMON-Web is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * UMLMON-Web is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with UMLMON-Web; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * </>
 *)

(* $Id: termemu_demo.ml 121 2005-06-12 13:56:40Z gerd $ *)

module Cl = Umlmonctrl_clnt.Ctrl.V1

let main() =
  let cgi = new Netcgi.std_activation () in
  let ues = Unixqueue.create_unix_event_system() in
  let client = Umlmon_client.create_client ues "test" in
  (* ignore(Umlmon_client.authenticate client "secret"); *)
  let emulator = new Termemu.terminal_emulator 80 24 in

  (* Output initial stuff *)
  cgi # set_header();
  cgi # output # output_string "<html>\n";
  cgi # output # output_string "<head>\n";
  cgi # output # output_string "<link type=\"text/css\" rel=\"stylesheet\" href=\"termemu_demo.css\">\n";
  cgi # output # output_string "</head>\n";
  cgi # output # output_string "<body>\n";
  cgi # output # output_string "<pre class=\"console\" id=\"con0\">\n";
  for n = 1 to 24 do
    for k = 1 to 80 do
      cgi # output # output_string "&nbsp;"
    done;
    cgi # output # output_string "<br>\n"
  done;
  cgi # output # output_string "</pre>";
  cgi # output # flush();

  (* Wait for arriving data *)
  while true do
    match Cl.read client ("con1", 10l) with
      | `code_ok data ->
	  for k = 0 to String.length data - 1 do
	    emulator # output_char data.[k]
	  done;
	  (* Output update *)
	  cgi # output # output_string "<script type='text/javascript'>\n";
	  cgi # output # output_string "document.getElementById('con0').innerHTML = \"";
	  cgi # output # output_string (emulator # screen_as_html);
	  cgi # output # output_string "\";\n";
	  cgi # output # output_string "</script>\n";
	  cgi # output # flush();

      | `code_interrupt ->
	  (* Output keep-alive data *)
	  cgi # output # output_string "<!-- -->\n";
	  cgi # output # flush();

      | _ ->
	  exit 0
  done
;;


main()
;;
